#Setting Background
bgcolors = ['#2DD7AA','#28AFFA','#4DD0E1','#97E345','#C0C5CF']
bg = new BackgroundLayer backgroundColor:bgcolors[0]

#Counter
counter = 1

#Getting Context
phonewidth = Framer.Device.screen.width
phoneheight = Framer.Device.screen.height
myspring = 'spring(400,36,0.12)'
defaultstyle = color:'#aaa',fontSize:'30px'

#Positioning
topposition = phoneheight/2 
cardwidth = phonewidth*0.8
defaultx = (phonewidth-cardwidth)/2

#Enabling Dragging
dragging = (el) ->
	
	el.draggable.enabled = true
	el.draggable.speedY = 0

#Initial Card
card = new Layer width:cardwidth, height:cardwidth, borderRadius:6, backgroundColor:'#fff',shadowY:8,shadowBlur:12,shadowColor:'rgba(0,0,0,0.2)'
card.centerX()
card.midY = topposition

dragging(card)	
mycard = card

Utils.labelLayer(card,"Card "+counter)

card.style = defaultstyle

# Functions

#Handling Dragevents
draginit = () ->

	mycard.on Events.DragStart,->
		mycard.animate
			properties:
				scale:1.05
				shadowY:10
			curve:myspring
		
	mycard.on Events.DragMove,->
		mycard.rotation = (mycard.x/750)*30
		if mycard.x < -phonewidth/3 || mycard.x > phonewidth/3
			mycard.animate
				properties:
					opacity:0.8
				curve:myspring
		else
			mycard.animate
				properties:
					opacity:1
				curve:myspring
	
	mycard.on Events.DragEnd,->
		
		mycard.animate
			properties:
				scale:1
				shadowY:8
			curve:myspring
				
		if mycard.x < -phonewidth/2
			dismissleft()
		else if mycard.x > phonewidth/2
			dismissright()
		else
			bounceback()

#Go Left				
dismissleft = () ->
	
	goleft = mycard.animate
		properties:
			x:-(phonewidth*2)
			opacity:0
		curve:myspring	
	
	trash = mycard
	goleft.on "end", -> trash.destroy()
	createcard()

#Go Right
dismissright = () ->
	
	goright = mycard.animate
		properties:
			x:phonewidth*2
			opacity:0
		curve:myspring
	
	trash = mycard
	goright.on "end",-> trash.destroy()	
	createcard()

#Send Back
bounceback = () ->
	
	mycard.animate
		properties:
			x:defaultx
			rotation:0
			opacity:1
		curve:myspring
	
#Creating Card and Animate it
createcard = () ->
	
	counter++
	
	newcard = new Layer width:cardwidth, height:cardwidth,x:defaultx, midY:phoneheight/1.5, borderRadius:6, backgroundColor:'#fff',opacity:0,scale:0.5,shadowY:8,shadowBlur:15,shadowColor:'rgba(0,0,0,0.2)'
	Utils.labelLayer(newcard,"Card "+counter)
	
	newcard.style = defaultstyle
	newcard.animate
		delay:0.2
		properties:
			x:defaultx
			midY:topposition
			opacity:1
			scale:1
		curve:myspring

	randbg = Math.floor(Math.random() * 5) #Creating Random Number between 0-4
	bg.backgroundColor = bgcolors[randbg] #Changing backgroundColor
	mycard = newcard #Assign it to mycard			
	dragging(newcard)#Make it draggable
	draginit() #Re-initiate Event Handler

#Initiate	
draginit()
